/* Data types
 * by Catid (cat02e@fsu.edu)
 */

#pragma once
#ifndef TYPES_H
#define TYPES_H

/* Includes
 * STL classes
 */
#include <fstream>
#include <string>
#include <map>
#include <list>
using namespace std;

namespace cat
{

	/* Basic types
	* Microsoft-specific, change these when porting to other platforms
	*/
	typedef unsigned __int8		uint8;
	typedef signed __int8		sint8;
	typedef unsigned __int16	uint16;
	typedef signed __int16		sint16;
	typedef unsigned __int32	uint32;
	typedef signed __int32		sint32;
	typedef unsigned __int64	uint64;
	typedef signed __int64		sint64;

	/* Byte-order swapping
	* Macintosh/Alpha/network inter-op
	*/
	inline uint16 boswap16(uint16 n) { return (n << 8) | (n >> 8); }
	inline uint32 boswap32(uint32 n) { return (n << 24) | ((n & 0x0000ff00) << 8) | ((n & 0x00ff0000) >> 8) | (n >> 24); }

}

#endif // TYPES_H
